<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (15) on Fri Jun 18 20:43:06 CEST 2021 -->
<title>AuthorController</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2021-06-18">
<meta name="description" content="declaration: package: fr.iut.librarymanagement.controller, class: AuthorController">
<meta name="generator" content="javadoc/ClassWriterImpl">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../script-dir/jquery-ui.min.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../jquery-ui.overrides.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
<script type="text/javascript" src="../../../../script-dir/jquery-3.5.1.min.js"></script>
<script type="text/javascript" src="../../../../script-dir/jquery-ui.min.js"></script>
</head>
<body class="class-declaration-page">
<script type="text/javascript">var data = {"i0":10,"i1":10,"i2":10,"i3":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "alt-color";
var rowColor = "row-color";
var tableTab = "table-tab";
var activeTableTab = "active-table-tab";
var pathtoroot = "../../../../";
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<div class="flex-box">
<header role="banner" class="flex-header">
<nav role="navigation">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="top-nav" id="navbar.top">
<div class="skip-nav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<ul id="navbar.top.firstrow" class="nav-list" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="nav-bar-cell1-rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="sub-nav">
<div>
<ul class="sub-nav-list">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="sub-nav-list">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<div class="nav-list-search"><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</div>
</div>
<!-- ========= END OF TOP NAVBAR ========= -->
<span class="skip-nav" id="skip.navbar.top">
<!--   -->
</span></nav>
</header>
<div class="flex-content">
<main role="main">
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="sub-title"><span class="package-label-in-type">Package</span>&nbsp;<a href="package-summary.html">fr.iut.librarymanagement.controller</a></div>
<h1 title="Class AuthorController" class="title">Class AuthorController</h1>
</div>
<div class="inheritance" title="Inheritance Tree">java.lang.Object
<div class="inheritance">fr.iut.librarymanagement.controller.AuthorController</div>
</div>
<section class="description">
<hr>
<pre>@RestController
public class <span class="type-name-label">AuthorController</span>
extends java.lang.Object</pre>
<div class="block">Controller for authors</div>
<dl class="notes">
<dt>See Also:</dt>
<dd><a href="../domain/Author.html" title="class in fr.iut.librarymanagement.domain"><code>Author</code></a></dd>
</dl>
</section>
<section class="summary">
<ul class="summary-list">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<li>
<section class="constructor-summary" id="constructor.summary">
<h2>Constructor Summary</h2>
<div class="member-summary">
<table class="summary-table">
<caption><span>Constructors</span></caption>
<thead>
<tr>
<th class="col-first" scope="col">Constructor</th>
<th class="col-last" scope="col">Description</th>
</tr>
</thead>
<tbody>
<tr class="alt-color">
<th class="col-constructor-name" scope="row"><code><span class="member-name-link"><a href="#%3Cinit%3E(fr.iut.librarymanagement.repository.AuthorRepository)">AuthorController</a></span>&#8203;(<a href="../repository/AuthorRepository.html" title="interface in fr.iut.librarymanagement.repository">AuthorRepository</a>&nbsp;authorRepository)</code></th>
<td class="col-last">&nbsp;</td>
</tr>
</tbody>
</table>
</div>
</section>
</li>
<!-- ========== METHOD SUMMARY =========== -->
<li>
<section class="method-summary" id="method.summary">
<h2>Method Summary</h2>
<div class="member-summary" id="method-summary-table">
<div class="table-tabs" role="tablist" aria-orientation="horizontal"><button role="tab" aria-selected="true" aria-controls="method-summary-table.tabpanel" tabindex="0" onkeydown="switchTab(event)" id="t0" class="active-table-tab">All Methods</button><button role="tab" aria-selected="false" aria-controls="method-summary-table.tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t2" class="table-tab" onclick="show(2);">Instance Methods</button><button role="tab" aria-selected="false" aria-controls="method-summary-table.tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t4" class="table-tab" onclick="show(8);">Concrete Methods</button></div>
<div id="method-summary-table.tabpanel" role="tabpanel">
<table class="summary-table" aria-labelledby="t0">
<thead>
<tr>
<th class="col-first" scope="col">Modifier and Type</th>
<th class="col-second" scope="col">Method</th>
<th class="col-last" scope="col">Description</th>
</tr>
</thead>
<tbody>
<tr class="alt-color" id="i0">
<td class="col-first"><code><a href="../domain/Author.html" title="class in fr.iut.librarymanagement.domain">Author</a></code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#addAuthor(fr.iut.librarymanagement.domain.Author)">addAuthor</a></span>&#8203;(<a href="../domain/Author.html" title="class in fr.iut.librarymanagement.domain">Author</a>&nbsp;author)</code></th>
<td class="col-last">
<div class="block">Create an author</div>
</td>
</tr>
<tr class="row-color" id="i1">
<td class="col-first"><code>java.util.List&lt;<a href="../domain/Author.html" title="class in fr.iut.librarymanagement.domain">Author</a>&gt;</code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#authorList(java.lang.String,java.lang.String)">authorList</a></span>&#8203;(java.lang.String&nbsp;lastname,
java.lang.String&nbsp;firstname)</code></th>
<td class="col-last">
<div class="block">Get all authors, or looking for all authors by firstname or lastname</div>
</td>
</tr>
<tr class="alt-color" id="i2">
<td class="col-first"><code><a href="../domain/Author.html" title="class in fr.iut.librarymanagement.domain">Author</a></code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#editAuthor(org.bson.types.ObjectId,java.lang.String,java.lang.String)">editAuthor</a></span>&#8203;(org.bson.types.ObjectId&nbsp;id,
java.lang.String&nbsp;lastname,
java.lang.String&nbsp;firstname)</code></th>
<td class="col-last">
<div class="block">Update an author</div>
</td>
</tr>
<tr class="row-color" id="i3">
<td class="col-first"><code>java.util.Optional&lt;<a href="../domain/Author.html" title="class in fr.iut.librarymanagement.domain">Author</a>&gt;</code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#getAuthorById(org.bson.types.ObjectId)">getAuthorById</a></span>&#8203;(org.bson.types.ObjectId&nbsp;id)</code></th>
<td class="col-last">
<div class="block">Get an author by its ID</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<div class="inherited-list">
<h3 id="methods.inherited.from.class.java.lang.Object">Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></div>
</section>
</li>
</ul>
</section>
<section class="details">
<ul class="details-list">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<li>
<section class="constructor-details" id="constructor.detail">
<h2>Constructor Details</h2>
<ul class="member-list">
<li>
<section class="detail" id="&lt;init&gt;(fr.iut.librarymanagement.repository.AuthorRepository)">
<h3>AuthorController</h3>
<div class="member-signature"><span class="modifiers">public</span>&nbsp;<span class="member-name">AuthorController</span>&#8203;(<span class="parameters"><a href="../repository/AuthorRepository.html" title="interface in fr.iut.librarymanagement.repository">AuthorRepository</a>&nbsp;authorRepository)</span></div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>authorRepository</code> - The AuthorRepository</dd>
</dl>
</section>
</li>
</ul>
</section>
</li>
<!-- ============ METHOD DETAIL ========== -->
<li>
<section class="method-details" id="method.detail">
<h2>Method Details</h2>
<ul class="member-list">
<li>
<section class="detail" id="authorList(java.lang.String,java.lang.String)">
<h3>authorList</h3>
<div class="member-signature"><span class="annotations">@GetMapping(path="/authors",
            produces="Application/json")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type">java.util.List&lt;<a href="../domain/Author.html" title="class in fr.iut.librarymanagement.domain">Author</a>&gt;</span>&nbsp;<span class="member-name">authorList</span>&#8203;(<span class="parameters">@RequestParam(name="lastname",required=false)
java.lang.String&nbsp;lastname,
@RequestParam(name="firstname",required=false)
java.lang.String&nbsp;firstname)</span></div>
<div class="block">Get all authors, or looking for all authors by firstname or lastname</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>lastname</code> - To looking for by lastname</dd>
<dd><code>firstname</code> - To looking for by firstname</dd>
<dt>Returns:</dt>
<dd>A list of Author</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="getAuthorById(org.bson.types.ObjectId)">
<h3>getAuthorById</h3>
<div class="member-signature"><span class="annotations">@GetMapping(path="/author/{id}",
            produces="Application/json")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type">java.util.Optional&lt;<a href="../domain/Author.html" title="class in fr.iut.librarymanagement.domain">Author</a>&gt;</span>&nbsp;<span class="member-name">getAuthorById</span>&#8203;(<span class="parameters">@PathVariable
org.bson.types.ObjectId&nbsp;id)</span></div>
<div class="block">Get an author by its ID</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>id</code> - The ID of the author</dd>
<dt>Returns:</dt>
<dd>The author</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="addAuthor(fr.iut.librarymanagement.domain.Author)">
<h3>addAuthor</h3>
<div class="member-signature"><span class="annotations">@PostMapping(path="/author",
             consumes="Application/json")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="../domain/Author.html" title="class in fr.iut.librarymanagement.domain">Author</a></span>&nbsp;<span class="member-name">addAuthor</span>&#8203;(<span class="parameters">@RequestBody
<a href="../domain/Author.html" title="class in fr.iut.librarymanagement.domain">Author</a>&nbsp;author)</span></div>
<div class="block">Create an author</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>author</code> - The author to be created</dd>
<dt>Returns:</dt>
<dd>The new author</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="editAuthor(org.bson.types.ObjectId,java.lang.String,java.lang.String)">
<h3>editAuthor</h3>
<div class="member-signature"><span class="annotations">@PutMapping(path="/author/{id}")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="../domain/Author.html" title="class in fr.iut.librarymanagement.domain">Author</a></span>&nbsp;<span class="member-name">editAuthor</span>&#8203;(<span class="parameters">@PathVariable
org.bson.types.ObjectId&nbsp;id,
@RequestParam(name="lastname",required=false)
java.lang.String&nbsp;lastname,
@RequestParam(name="firstname",required=false)
java.lang.String&nbsp;firstname)</span></div>
<div class="block">Update an author</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>id</code> - The ID of the author to be modified</dd>
<dd><code>lastname</code> - The lastname of the author</dd>
<dd><code>firstname</code> - The firstname of the author</dd>
<dt>Returns:</dt>
<dd>The modified author</dd>
</dl>
</section>
</li>
</ul>
</section>
</li>
</ul>
</section>
<!-- ========= END OF CLASS DATA ========= -->
</main>
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottom-nav" id="navbar.bottom">
<div class="skip-nav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<ul id="navbar.bottom.firstrow" class="nav-list" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="nav-bar-cell1-rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="sub-nav">
<div>
<ul class="sub-nav-list">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="sub-nav-list">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
</div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<span class="skip-nav" id="skip.navbar.bottom">
<!--   -->
</span></nav>
</footer>
</div>
</div>
</body>
</html>
